Global Max.l
Global idx.l
Global Zoom.l

Procedure Showimage()
  SetGadgetText(6,Str(idx+1)+"/"+Str(max))
  SetGadgetText(8,"Zoom "+Str(Zoom)+"%")
  img=Print_GetPreviewImage(idx)
  If img
    SetGadgetState(1,ImageID(img))
  EndIf
EndProcedure

Procedure Print_Preview(Preview)
  ;Print_SetDebug(#True)
  
  Print_OpenPrinter("","PAPERSIZE="+Str(#DMPAPER_A4)+",ORIENTATION="+Str(#DMORIENT_PORTRAIT))
  
  If Preview=#True
    pw=(450*Zoom)/100
    Print_StartPreview(pw)
    xa=Print_GetDeviceCaps(#HORZRES)+20
    ya=Print_GetDeviceCaps(#VERTRES)+20
    SetGadgetAttribute(0,#PB_ScrollArea_InnerWidth,xa)
    SetGadgetAttribute(0,#PB_ScrollArea_InnerHeight,ya)
  Else
    Print_StartPrinting("TEST")
  EndIf
  
  ; Start preview
  Print_Font("Arial",28,#PB_Font_Bold)
  text$="PrinterLib Barcode Test Page"
  len=Print_TextWidth(text$)
  Print_Text(210/2-len/2,5,text$)
  
  h1.f=14
  w1.f=0.1905
  w2.f=0.3175
  w3.f=0.4445
  w4.f=0.5715
  w5.f=0.6985
  edgebar.f=1.5
  xoffset.f=0
  yoffset.f=0.6
  
  y1.f=20
  x.f=100:y.f=100
  
  Print_Font("Arial",6)
  
  align1=#PRINT_TEXT_BOTTOM
  ;align1=#PRINT_TEXT_BOTTOM|#PRINT_TEXT_CENTER
  ;align1=#PRINT_TEXT_BOTTOM|#PRINT_TEXT_RIGHT
  ;align1=#PRINT_TEXT_TOP
  ;align1=#PRINT_TEXT_TOP|#PRINT_TEXT_CENTER
  ;align1=#PRINT_TEXT_TOP|#PRINT_TEXT_RIGHT
  
  align=align1
  Print_Barcode_Code128(x+5,y+5,"EP12345678A1234",h1,w3,align,xoffset,yoffset,#PRINT_BARCODE_CODE128_AUTO)
  align=align1|#PRINT_ROTATE_90
  Print_Barcode_Code128(x+5,y-5,"EP12345678A1234",h1,w3,align,xoffset,yoffset,#PRINT_BARCODE_CODE128_AUTO)
  align=align1|#PRINT_ROTATE_180
  Print_Barcode_Code128(x-5,y-5,"EP12345678A1234",h1,w3,align,xoffset,yoffset,#PRINT_BARCODE_CODE128_AUTO)
  align=align1|#PRINT_ROTATE_270
  Print_Barcode_Code128(x-5,y+5,"EP12345678A1234",h1,w3,align,xoffset,yoffset,#PRINT_BARCODE_CODE128_AUTO)
  
  y+120
  ; ISBN test
  align=align1
  Print_Barcode_EAN13(x+5,y+5,"978389011528",h1,w3,align,yoffset,edgebar,#True)
  align=align1|#PRINT_ROTATE_90
  Print_Barcode_EAN13(x+5,y-5,"978389011528",h1,w3,align,yoffset,edgebar,#True)
  align=align1|#PRINT_ROTATE_180
  Print_Barcode_EAN13(x-5,y-5,"978389011528",h1,w3,align,yoffset,edgebar,#True)
  align=align1|#PRINT_ROTATE_270
  Print_Barcode_EAN13(x-5,y+5,"978389011528",h1,w3,align,yoffset,edgebar,#True)
  
  ; Preview end
  If Preview=#True
    Print_StopPreview()
  Else
    Print_StopPrinting()
  EndIf
  max=Print_GetPreviewCount()
  Showimage()
EndProcedure

Procedure Button_First()
  idx=0
  Showimage()
EndProcedure

Procedure Button_Left()
  If idx>0
    idx-1
  EndIf
  Showimage()
EndProcedure

Procedure Button_Right()
  If idx<(max-1)
    idx+1
  EndIf
  Showimage()
EndProcedure

Procedure Button_Last()
  If max>0
    idx=max-1
  Else
    idx=max
  EndIf
  Showimage()
EndProcedure

Procedure Button_Zoom()
  Select Zoom
    Case 100
      Zoom=150
    Case 150
      Zoom=200
    Case 200
      Zoom=300
    Case 300
      Zoom=400
    Case 400
      Zoom=500
    Case 500
      Zoom=800
    Case 800
      Zoom=100
  EndSelect
  
  Print_Preview(#True)
  Showimage()
EndProcedure

If OpenWindow(0,0,0,500,720,"Test",#PB_Window_SystemMenu)
  If CreateGadgetList(WindowID(0))
    ScrollAreaGadget(0,10,10,480,680, 470, 670, 30)
      ImageGadget(1,10,10,480,680,0)
    CloseGadgetList()
  EndIf
  ButtonGadget(2,10,695,20,20,"|<")
  ButtonGadget(3,30,695,20,20,"<")
  ButtonGadget(4,50,695,20,20,">")
  ButtonGadget(5,70,695,20,20,">|")
  TextGadget(6,100,695,40,20,"0/0",#PB_Text_Border)
  ButtonGadget(7,150,695,40,20,"Print")
  ButtonGadget(8,200,695,70,20,"Zoom 100%")
EndIf

idx=0
Zoom=100
Print_Preview(#True)
Showimage()

Repeat
  event=WaitWindowEvent()
  Select event
    Case #PB_Event_Gadget
      If EventType()=#PB_EventType_LeftClick
        Select EventGadget()
          Case 2
            Button_First()
          Case 3
            Button_Left()
          Case 4
            Button_Right()
          Case 5
            Button_Last()
          Case 7
            Print_Preview(#False)
          Case 8
            Button_Zoom()
        EndSelect
      EndIf
  EndSelect
Until event=#PB_Event_CloseWindow
; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 11
; Folding = --